static char rcsid[] = "$Id: urlget.c,v 2.1 1997/03/21 18:10:12 sxw Exp $";
/* 
 *  urlget.c - Prints the URL to stdout 
 *
 *  DEBUG: section  25, level 1           urlget - standalone liburl program.
 *  AUTHOR: Harvest derived
 *
 *  Harvest Indexer http://www.tardis.ed.ac.uk/harvest/
 *  ---------------------------------------------------
 *
 *  The Harvest Indexer is a continued development of code developed by
 *  the Harvest Project. Development is carried out by numerous individuals
 *  in the Internet community, and is not officially connected with the
 *  original Harvest Project or its funding sources.
 * 
 *  Please mail harvest@tardis.ed.ac.uk if you are interested in participating
 *  in the development effort.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/*  ----------------------------------------------------------------------
 *  Copyright (c) 1994, 1995.  All rights reserved.
 *  
 *    The Harvest software was developed by the Internet Research Task
 *    Force Research Group on Resource Discovery (IRTF-RD):
 *  
 *          Mic Bowman of Transarc Corporation.
 *          Peter Danzig of the University of Southern California.
 *          Darren R. Hardy of the University of Colorado at Boulder.
 *          Udi Manber of the University of Arizona.
 *          Michael F. Schwartz of the University of Colorado at Boulder.
 *          Duane Wessels of the University of Colorado at Boulder.
 *  
 *    This copyright notice applies to software in the Harvest
 *    ``src/'' directory only.  Users should consult the individual
 *    copyright notices in the ``components/'' subdirectories for
 *    copyright information about other software bundled with the
 *    Harvest source code distribution.
 *  
 *  TERMS OF USE
 *    
 *    The Harvest software may be used and re-distributed without
 *    charge, provided that the software origin and research team are
 *    cited in any use of the system.  Most commonly this is
 *    accomplished by including a link to the Harvest Home Page
 *    (http://harvest.cs.colorado.edu/) from the query page of any
 *    Broker you deploy, as well as in the query result pages.  These
 *    links are generated automatically by the standard Broker
 *    software distribution.
 *    
 *    The Harvest software is provided ``as is'', without express or
 *    implied warranty, and with no support nor obligation to assist
 *    in its use, correction, modification or enhancement.  We assume
 *    no liability with respect to the infringement of copyrights,
 *    trade secrets, or any patents, and are not responsible for
 *    consequential damages.  Proper use of the Harvest software is
 *    entirely the responsibility of the user.
 *  
 *  DERIVATIVE WORKS
 *  
 *    Users may make derivative works from the Harvest software, subject 
 *    to the following constraints:
 *  
 *      - You must include the above copyright notice and these 
 *        accompanying paragraphs in all forms of derivative works, 
 *        and any documentation and other materials related to such 
 *        distribution and use acknowledge that the software was 
 *        developed at the above institutions.
 *  
 *      - You must notify IRTF-RD regarding your distribution of 
 *        the derivative work.
 *  
 *      - You must clearly notify users that your are distributing 
 *        a modified version and not the original Harvest software.
 *  
 *      - Any derivative product is also subject to these copyright 
 *        and use restrictions.
 *  
 *    Note that the Harvest software is NOT in the public domain.  We
 *    retain copyright, as specified above.
 *  
 *  HISTORY OF FREE SOFTWARE STATUS
 *  
 *    Originally we required sites to license the software in cases
 *    where they were going to build commercial products/services
 *    around Harvest.  In June 1995 we changed this policy.  We now
 *    allow people to use the core Harvest software (the code found in
 *    the Harvest ``src/'' directory) for free.  We made this change
 *    in the interest of encouraging the widest possible deployment of
 *    the technology.  The Harvest software is really a reference
 *    implementation of a set of protocols and formats, some of which
 *    we intend to standardize.  We encourage commercial
 *    re-implementations of code complying to this set of standards.  
 *  
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "util.h"
#include "url.h"

static URL *up;

static void die(n)
     int n;
{
	if (up)
		url_close(up);
	finish_url();
	exit(n);
}

static void do_url(url)
     char *url;
{
	int n;
	int count=0;
	int status;
	static char buf[BUFSIZ];

	Log("Processing: %s\n", url);
	if ((up = url_open(url)) == NULL) {
		fprintf(stderr, "%s: is Invalid.\n", url);
		die(1);
	}

	/* This repeats around if a redirect is sent until we're at a proper
         * URL or until we've followed more hops than we're allowed to
         */
	while (((status=url_retrieve(up))==-1) && count<HTTP_MAX_REDIRECTS)
	  count++;

	if (status) {
		fprintf(stderr, "%s: Cannot retrieve.\n", up->url);
		die(1);
	}
	if ((up->fp = fopen(up->filename, "r")) == NULL) {
		perror(up->filename);
		die(1);
	}
	Debug(25, 1, ("Last-Modified: %ld\n", up->lmt));
	while ((n = fread(buf, 1, BUFSIZ - 1, up->fp)) > 0) {
		fwrite(buf, 1, n, stdout);
	}
	fclose(up->fp);
	up->fp = NULL;
	url_close(up);
	up = NULL;
}

int main(argc, argv)
     int argc;
     char **argv;
{
	extern int use_local_cache;

	if (argc < 2) {
		fprintf(stderr, "Usage: urlget [--no-cache] url [... url]\n");
		exit(1);
	}
	init_log(stderr, stderr);
	debug_init();
	init_url();
	url_purge();
	while (--argc > 0) {
		++argv;
		if (!strcmp(*argv, "--no-cache")) {
			use_local_cache = 0;
			continue;
		}
		if (!strncmp(*argv, "-D", 2)) {
			debug_flag(*argv);
			continue;
		}
		do_url(*argv);
	}
	die(0);
	/* NOTREACHED */
}
